from qommon.storage import StorableObject

class App(StorableObject):
    _names = 'apps'

    name = None
    document_root = None
    scgi_port = None

    vhost_template = '''<VirtualHost *:80>
    ServerAdmin %%(admin_email)s
    ServerName %%(hostname)s
    DocumentRoot %(document_root)s

    SCGIMount / 127.0.0.1:%(scgi_port)s
    <LocationMatch "^/(css|images|js)/.*">
      SCGIHandler off
    </LocationMatch>

    CustomLog %%(vhost_logs_dir)s/access.log combined
    ErrorLog %%(vhost_logs_dir)s/error.log

</VirtualHost>
'''

    def get_vhost_template(self):
        return self.vhost_template % self.__dict__

